#include <GL/glut.h>
#include <math.h> 

#define MAXPOINTS 50
GLsizei winWidth = 300, winHeight = 266;   // Initial display-window size.

GLint prevX, prevY, angToX, angToY;
GLint range=1, sides=24; 
GLfloat pts[MAXPOINTS][2];
GLfloat PI=3.141592653, radius=0.125; 
bool rotating=false; 

void init(void)
{
   glClearColor(1.0, 1.0, 1.0, 1.0);  // Set display-window color to blue.
   
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity( );
   
   for(int n=0; n<sides; ++n)
      { pts[n][0] = radius * cos(n*2.*PI/sides); 
        pts[n][1] = radius * sin(n*2.*PI/sides);
      } 
}

void showFlag()
{
  int k, hh = 0; // W@b
   
  glPushMatrix(); 
  //===== aPC 
  glBegin(GL_QUADS);
    glColor3f(1.0, 0.0, 0.0); 
    glVertex3f(-1, 1, hh);
    glVertex3f(-1,-1, hh);
    glVertex3f( 1,-1, hh);
    glVertex3f( 1, 1, hh);
    glColor3f(0.0, 0.0, 0.5);
    glVertex3f(-1, 1, hh);
    glVertex3f(-1, 0, hh);
    glVertex3f( 0, 0, hh);
    glVertex3f( 0, 1, hh); 
  glEnd();
  //===== դ~ 
  glTranslatef(-0.5, +0.5, 0.0); 
  glColor3f(1.0, 1.0, 1.0);
  glBegin(GL_POLYGON); 
    for(k=0; k<sides; ++k)
       { glVertex3f(pts[k][0], pts[k][1], hh); 
       } 
  glEnd();  
  for(k=0; k<=12; ++k)
     { glRotatef(30, 0.0, 0.0, 1.0); 
       glBegin(GL_TRIANGLE_FAN); //_FAN); 
         
         glVertex3f(0.25,   0.0,    hh); 
         glVertex3f(0.1385, 0.0299, hh);
         glVertex3f(0.1417, 0.0,    hh);
         glVertex3f(0.1385,-0.0299, hh);
         //glVertex3f();
       glEnd();
     } 
  
  glPopMatrix(); 
 
  glFlush( );
}

void displayFcn(void)
{
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );     //  Clear display window.

   //glEnable(GL_DEPTH_TEST); 
   //glPolygonMode(GL_BACK, GL_LINE); // p. 208 
  
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity(); 
   glRotatef(angToX, 1.0, 0.0, 0.0); 
   glRotatef(angToY, 0.0, 1.0, 0.0); 
   
   showFlag();
   
   glutSwapBuffers(); 
}

void winReshapeFcn(GLint newWidth, GLint newHeight)
{
   /*  Reset viewport and projection parameters  */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity( );
   float scale = 1.5; 
   glOrtho(-range*scale, range*scale, -range*scale, range*scale, -range*scale, range*scale);
   
   /*  Reset display-window size parameters.  */
   glMatrixMode(GL_MODELVIEW);
   glViewport(0, 0, newWidth, newHeight);
   
   winWidth  = newWidth;
   winHeight = newHeight;
    
   glutPostRedisplay(); 
}

void mouseFcn(int button, int action, int x, int y)
{
  if( action == GLUT_DOWN )
    { rotating = true; 
      prevX = x;
      prevY = y; 
    } 
  else if( action == GLUT_UP )           
    rotating = false; 
}
 
void mouseMoving(GLint xMouse, GLint yMouse)
{ 
  if( rotating )
    { int dx = xMouse - prevX;
      int dy = yMouse - prevY;
      prevX = xMouse;
      prevY = yMouse;
      angToY += dx;
      angToX += dy;
      glutPostRedisplay(); 
    }  
}
// GLubyte = unsigned char 
void keyboardFcn(GLubyte key, GLint xMouse, GLint yMouse) 
{ 
  if( key==' ' )  // space pressed 
    { angToX=angToY= 0; 
    }
     
  glutPostRedisplay();    
} 

void specialKeyFcn(GLint specialKey, GLint xMouse, GLint yMouse) 
{ 
  GLint deg=1; 
  
  switch(specialKey)
    { case GLUT_KEY_UP    : angToX -= deg;  break; 
      case GLUT_KEY_DOWN  : angToX += deg;  break;
      case GLUT_KEY_LEFT  : angToY -= deg;  break;
      case GLUT_KEY_RIGHT : angToY += deg;  break;
    }
  glutPostRedisplay();    
} 

int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); // GLUT_DOUBLE 
   glutInitWindowPosition(100, 100);
   glutInitWindowSize(winWidth, winHeight);
   glutCreateWindow("Showing National Flag");

   init();
   glutDisplayFunc( displayFcn );
   glutReshapeFunc( winReshapeFcn );
   
   glutKeyboardFunc( keyboardFcn );  // void keyboardFcn(GLubyte key, GLint xMouse, GLint yMouse) 
   glutSpecialFunc( specialKeyFcn ); //void specialKeyFcn(GLint specialKey, GLint xMouse, GLint yMouse)
   glutMouseFunc( mouseFcn );    //void mouseMoving(GLint xMouse, GLint yMouse) 
   glutMotionFunc(mouseMoving);  // void mouseMoving(GLint xMouse, GLint yMouse);   
  
   glutMainLoop();
}

